/*
 * Copyright (C) 2007-2009 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#include <assert.h>
#include <stdio.h>

#include "glue.h"

#include "chip_intel_x86_64.h"

#include "cpu_intel_x86_64.h"

struct cpssp {
	void *chip;
};

void *
cpu_intel_x86_64_create(
	const char *name,
	struct sig_manage *port_manage,
	struct sig_host775_conn *port_conn
)
{
	struct cpssp *cpssp;

	cpssp = shm_alloc(sizeof(*cpssp));
	assert(cpssp);

	cpssp->chip = chip_intel_x86_64_create(name,
			port_manage,
			port_conn->power,
			port_conn->n_reset,
			port_conn->n_init,
			port_conn->lint0,
			port_conn->lint0,
			port_conn->smi,
			port_conn->n_ferr,
			port_conn->n_ignne,
			port_conn->a20,
			port_conn->icc,
			port_conn->main);

	return cpssp;
}

void
cpu_intel_x86_64_destroy(void *_cpssp)
{
	struct cpssp *cpssp = _cpssp;

	chip_intel_x86_64_destroy(cpssp->chip);

	shm_free(cpssp);
}

void
cpu_intel_x86_64_suspend(void *_cpssp, FILE *fComp)
{
	struct cpssp *cpssp = _cpssp;

	chip_intel_x86_64_suspend(cpssp->chip, fComp);
}

void
cpu_intel_x86_64_resume(void *_cpssp, FILE *fComp)
{
	struct cpssp *cpssp = _cpssp;

	chip_intel_x86_64_resume(cpssp->chip, fComp);
}
