/*
 * Copyright (C) 2012 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#include "config.h"

#include <assert.h>
#include <stdio.h>

#include "glue-gui.h"

#include "zuse23_console_gui.h"
#ifdef HAVE_GTK
#include "zuse23_console_gui_gtk.h"
#endif

void *
zuse23_console_gui_create(
	unsigned int page,
	const char *name,
	struct sig_manage *port_manage,
	struct sig_boolean *port_misc_lamp0,
	struct sig_boolean *port_misc_lamp1,
	struct sig_boolean *port_misc_lamp2,
	struct sig_boolean *port_misc_lamp3,
	struct sig_boolean *port_misc_lamp4,
	struct sig_boolean *port_misc_lamp5,
	struct sig_boolean *port_misc_lamp6,
	struct sig_boolean *port_misc_lamp7,
	struct sig_boolean *port_misc_lamp8,
	struct sig_boolean *port_misc_lamp9,
	struct sig_boolean *port_bef_lamp39,
	struct sig_boolean *port_bef_lamp38,
	struct sig_boolean *port_bef_lamp37,
	struct sig_boolean *port_bef_lamp36,
	struct sig_boolean *port_bef_lamp35,
	struct sig_boolean *port_bef_lamp34,
	struct sig_boolean *port_bef_lamp33,
	struct sig_boolean *port_bef_lamp32,
	struct sig_boolean *port_bef_lamp31,
	struct sig_boolean *port_bef_lamp30,
	struct sig_boolean *port_bef_lamp29,
	struct sig_boolean *port_bef_lamp28,
	struct sig_boolean *port_bef_lamp27,
	struct sig_boolean *port_bef_lamp26,
	struct sig_boolean *port_bef_lamp25,
	struct sig_boolean *port_bef_lamp24,
	struct sig_boolean *port_bef_lamp23,
	struct sig_boolean *port_bef_lamp22,
	struct sig_boolean *port_bef_lamp21,
	struct sig_boolean *port_bef_lamp20,
	struct sig_boolean *port_bef_lamp19,
	struct sig_boolean *port_bef_lamp18,
	struct sig_boolean *port_bef_lamp17,
	struct sig_boolean *port_bef_lamp16,
	struct sig_boolean *port_bef_lamp15,
	struct sig_boolean *port_bef_lamp14,
	struct sig_boolean *port_bef_lamp13,
	struct sig_boolean *port_bef_lamp12,
	struct sig_boolean *port_bef_lamp11,
	struct sig_boolean *port_bef_lamp10,
	struct sig_boolean *port_bef_lamp9,
	struct sig_boolean *port_bef_lamp8,
	struct sig_boolean *port_bef_lamp7,
	struct sig_boolean *port_bef_lamp6,
	struct sig_boolean *port_bef_lamp5,
	struct sig_boolean *port_bef_lamp4,
	struct sig_boolean *port_bef_lamp3,
	struct sig_boolean *port_bef_lamp2,
	struct sig_boolean *port_bef_lamp1,
	struct sig_boolean *port_bef_lamp0,
	struct sig_boolean *port_akku_lamp39,
	struct sig_boolean *port_akku_lamp38,
	struct sig_boolean *port_akku_lamp37,
	struct sig_boolean *port_akku_lamp36,
	struct sig_boolean *port_akku_lamp35,
	struct sig_boolean *port_akku_lamp34,
	struct sig_boolean *port_akku_lamp33,
	struct sig_boolean *port_akku_lamp32,
	struct sig_boolean *port_akku_lamp31,
	struct sig_boolean *port_akku_lamp30,
	struct sig_boolean *port_akku_lamp29,
	struct sig_boolean *port_akku_lamp28,
	struct sig_boolean *port_akku_lamp27,
	struct sig_boolean *port_akku_lamp26,
	struct sig_boolean *port_akku_lamp25,
	struct sig_boolean *port_akku_lamp24,
	struct sig_boolean *port_akku_lamp23,
	struct sig_boolean *port_akku_lamp22,
	struct sig_boolean *port_akku_lamp21,
	struct sig_boolean *port_akku_lamp20,
	struct sig_boolean *port_akku_lamp19,
	struct sig_boolean *port_akku_lamp18,
	struct sig_boolean *port_akku_lamp17,
	struct sig_boolean *port_akku_lamp16,
	struct sig_boolean *port_akku_lamp15,
	struct sig_boolean *port_akku_lamp14,
	struct sig_boolean *port_akku_lamp13,
	struct sig_boolean *port_akku_lamp12,
	struct sig_boolean *port_akku_lamp11,
	struct sig_boolean *port_akku_lamp10,
	struct sig_boolean *port_akku_lamp9,
	struct sig_boolean *port_akku_lamp8,
	struct sig_boolean *port_akku_lamp7,
	struct sig_boolean *port_akku_lamp6,
	struct sig_boolean *port_akku_lamp5,
	struct sig_boolean *port_akku_lamp4,
	struct sig_boolean *port_akku_lamp3,
	struct sig_boolean *port_akku_lamp2,
	struct sig_boolean *port_akku_lamp1,
	struct sig_boolean *port_akku_lamp0,
	struct sig_boolean *port_misc_switch0,
	struct sig_boolean *port_misc_switch1,
	struct sig_boolean *port_misc_switch2,
	struct sig_boolean *port_misc_switch3,
	struct sig_boolean *port_misc_switch4,
	struct sig_boolean *port_misc_switch5,
	struct sig_boolean *port_misc_switch6,
	struct sig_boolean *port_misc_switch7,
	struct sig_boolean *port_misc_switch8,
	struct sig_boolean *port_misc_switch9,
	struct sig_boolean *port_sperr_switch7,
	struct sig_boolean *port_sperr_switch6,
	struct sig_boolean *port_sperr_switch5,
	struct sig_boolean *port_sperr_switch4,
	struct sig_boolean *port_sperr_switch3,
	struct sig_boolean *port_sperr_switch2,
	struct sig_boolean *port_sperr_switch1,
	struct sig_boolean *port_loe_aus_switch,
	struct sig_boolean *port_misc_switch18,
	struct sig_boolean *port_adr_p1_aus_switch,
	struct sig_boolean *port_bed_switch4,
	struct sig_boolean *port_bed_switch3,
	struct sig_boolean *port_bed_switch2,
	struct sig_boolean *port_bed_switch1,
	struct sig_boolean *port_bed_switch0,
	struct sig_boolean *port_bed_ein_switch,
	struct sig_boolean *port_adr_stop_ein_switch,
	struct sig_boolean *port_adr_stop_switch12,
	struct sig_boolean *port_adr_stop_switch11,
	struct sig_boolean *port_adr_stop_switch10,
	struct sig_boolean *port_adr_stop_switch9,
	struct sig_boolean *port_adr_stop_switch8,
	struct sig_boolean *port_adr_stop_switch7,
	struct sig_boolean *port_adr_stop_switch6,
	struct sig_boolean *port_adr_stop_switch5,
	struct sig_boolean *port_adr_stop_switch4,
	struct sig_boolean *port_adr_stop_switch3,
	struct sig_boolean *port_adr_stop_switch2,
	struct sig_boolean *port_adr_stop_switch1,
	struct sig_boolean *port_adr_stop_switch0,
	struct sig_boolean *port_bef_switch39,
	struct sig_boolean *port_bef_switch38,
	struct sig_boolean *port_bef_switch37,
	struct sig_boolean *port_bef_switch36,
	struct sig_boolean *port_bef_switch35,
	struct sig_boolean *port_bef_switch34,
	struct sig_boolean *port_bef_switch33,
	struct sig_boolean *port_bef_switch32,
	struct sig_boolean *port_bef_switch31,
	struct sig_boolean *port_bef_switch30,
	struct sig_boolean *port_bef_switch29,
	struct sig_boolean *port_bef_switch28,
	struct sig_boolean *port_bef_switch27,
	struct sig_boolean *port_bef_switch26,
	struct sig_boolean *port_bef_switch25,
	struct sig_boolean *port_bef_switch24,
	struct sig_boolean *port_bef_switch23,
	struct sig_boolean *port_bef_switch22,
	struct sig_boolean *port_bef_switch21,
	struct sig_boolean *port_bef_switch20,
	struct sig_boolean *port_bef_switch19,
	struct sig_boolean *port_bef_switch18,
	struct sig_boolean *port_bef_switch17,
	struct sig_boolean *port_bef_switch16,
	struct sig_boolean *port_bef_switch15,
	struct sig_boolean *port_bef_switch14,
	struct sig_boolean *port_bef_switch13,
	struct sig_boolean *port_bef_switch12,
	struct sig_boolean *port_bef_switch11,
	struct sig_boolean *port_bef_switch10,
	struct sig_boolean *port_bef_switch9,
	struct sig_boolean *port_bef_switch8,
	struct sig_boolean *port_bef_switch7,
	struct sig_boolean *port_bef_switch6,
	struct sig_boolean *port_bef_switch5,
	struct sig_boolean *port_bef_switch4,
	struct sig_boolean *port_bef_switch3,
	struct sig_boolean *port_bef_switch2,
	struct sig_boolean *port_bef_switch1,
	struct sig_boolean *port_bef_switch0,
	struct sig_boolean *port_akku_switch39,
	struct sig_boolean *port_akku_switch38,
	struct sig_boolean *port_akku_switch37,
	struct sig_boolean *port_akku_switch36,
	struct sig_boolean *port_akku_switch35,
	struct sig_boolean *port_akku_switch34,
	struct sig_boolean *port_akku_switch33,
	struct sig_boolean *port_akku_switch32,
	struct sig_boolean *port_akku_switch31,
	struct sig_boolean *port_akku_switch30,
	struct sig_boolean *port_akku_switch29,
	struct sig_boolean *port_akku_switch28,
	struct sig_boolean *port_akku_switch27,
	struct sig_boolean *port_akku_switch26,
	struct sig_boolean *port_akku_switch25,
	struct sig_boolean *port_akku_switch24,
	struct sig_boolean *port_akku_switch23,
	struct sig_boolean *port_akku_switch22,
	struct sig_boolean *port_akku_switch21,
	struct sig_boolean *port_akku_switch20,
	struct sig_boolean *port_akku_switch19,
	struct sig_boolean *port_akku_switch18,
	struct sig_boolean *port_akku_switch17,
	struct sig_boolean *port_akku_switch16,
	struct sig_boolean *port_akku_switch15,
	struct sig_boolean *port_akku_switch14,
	struct sig_boolean *port_akku_switch13,
	struct sig_boolean *port_akku_switch12,
	struct sig_boolean *port_akku_switch11,
	struct sig_boolean *port_akku_switch10,
	struct sig_boolean *port_akku_switch9,
	struct sig_boolean *port_akku_switch8,
	struct sig_boolean *port_akku_switch7,
	struct sig_boolean *port_akku_switch6,
	struct sig_boolean *port_akku_switch5,
	struct sig_boolean *port_akku_switch4,
	struct sig_boolean *port_akku_switch3,
	struct sig_boolean *port_akku_switch2,
	struct sig_boolean *port_akku_switch1,
	struct sig_boolean *port_akku_switch0,
	struct sig_boolean *port_stop,
	struct sig_boolean *port_weiter,
	struct sig_boolean *port_start,
	struct sig_boolean *port_akku_ueb,
	struct sig_boolean *port_bef_ueb
)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		return zuse23_console_gui_gtk_create(page, name, port_manage,
				port_misc_lamp0,
				port_misc_lamp1,
				port_misc_lamp2,
				port_misc_lamp3,
				port_misc_lamp4,
				port_misc_lamp5,
				port_misc_lamp6,
				port_misc_lamp7,
				port_misc_lamp8,
				port_misc_lamp9,
				port_bef_lamp39,
				port_bef_lamp38,
				port_bef_lamp37,
				port_bef_lamp36,
				port_bef_lamp35,
				port_bef_lamp34,
				port_bef_lamp33,
				port_bef_lamp32,
				port_bef_lamp31,
				port_bef_lamp30,
				port_bef_lamp29,
				port_bef_lamp28,
				port_bef_lamp27,
				port_bef_lamp26,
				port_bef_lamp25,
				port_bef_lamp24,
				port_bef_lamp23,
				port_bef_lamp22,
				port_bef_lamp21,
				port_bef_lamp20,
				port_bef_lamp19,
				port_bef_lamp18,
				port_bef_lamp17,
				port_bef_lamp16,
				port_bef_lamp15,
				port_bef_lamp14,
				port_bef_lamp13,
				port_bef_lamp12,
				port_bef_lamp11,
				port_bef_lamp10,
				port_bef_lamp9,
				port_bef_lamp8,
				port_bef_lamp7,
				port_bef_lamp6,
				port_bef_lamp5,
				port_bef_lamp4,
				port_bef_lamp3,
				port_bef_lamp2,
				port_bef_lamp1,
				port_bef_lamp0,
				port_akku_lamp39,
				port_akku_lamp38,
				port_akku_lamp37,
				port_akku_lamp36,
				port_akku_lamp35,
				port_akku_lamp34,
				port_akku_lamp33,
				port_akku_lamp32,
				port_akku_lamp31,
				port_akku_lamp30,
				port_akku_lamp29,
				port_akku_lamp28,
				port_akku_lamp27,
				port_akku_lamp26,
				port_akku_lamp25,
				port_akku_lamp24,
				port_akku_lamp23,
				port_akku_lamp22,
				port_akku_lamp21,
				port_akku_lamp20,
				port_akku_lamp19,
				port_akku_lamp18,
				port_akku_lamp17,
				port_akku_lamp16,
				port_akku_lamp15,
				port_akku_lamp14,
				port_akku_lamp13,
				port_akku_lamp12,
				port_akku_lamp11,
				port_akku_lamp10,
				port_akku_lamp9,
				port_akku_lamp8,
				port_akku_lamp7,
				port_akku_lamp6,
				port_akku_lamp5,
				port_akku_lamp4,
				port_akku_lamp3,
				port_akku_lamp2,
				port_akku_lamp1,
				port_akku_lamp0,
				port_misc_switch0,
				port_misc_switch1,
				port_misc_switch2,
				port_misc_switch3,
				port_misc_switch4,
				port_misc_switch5,
				port_misc_switch6,
				port_misc_switch7,
				port_misc_switch8,
				port_misc_switch9,
				port_sperr_switch7,
				port_sperr_switch6,
				port_sperr_switch5,
				port_sperr_switch4,
				port_sperr_switch3,
				port_sperr_switch2,
				port_sperr_switch1,
				port_loe_aus_switch,
				port_misc_switch18,
				port_adr_p1_aus_switch,
				port_bed_switch4,
				port_bed_switch3,
				port_bed_switch2,
				port_bed_switch1,
				port_bed_switch0,
				port_bed_ein_switch,
				port_adr_stop_ein_switch,
				port_adr_stop_switch12,
				port_adr_stop_switch11,
				port_adr_stop_switch10,
				port_adr_stop_switch9,
				port_adr_stop_switch8,
				port_adr_stop_switch7,
				port_adr_stop_switch6,
				port_adr_stop_switch5,
				port_adr_stop_switch4,
				port_adr_stop_switch3,
				port_adr_stop_switch2,
				port_adr_stop_switch1,
				port_adr_stop_switch0,
				port_bef_switch39,
				port_bef_switch38,
				port_bef_switch37,
				port_bef_switch36,
				port_bef_switch35,
				port_bef_switch34,
				port_bef_switch33,
				port_bef_switch32,
				port_bef_switch31,
				port_bef_switch30,
				port_bef_switch29,
				port_bef_switch28,
				port_bef_switch27,
				port_bef_switch26,
				port_bef_switch25,
				port_bef_switch24,
				port_bef_switch23,
				port_bef_switch22,
				port_bef_switch21,
				port_bef_switch20,
				port_bef_switch19,
				port_bef_switch18,
				port_bef_switch17,
				port_bef_switch16,
				port_bef_switch15,
				port_bef_switch14,
				port_bef_switch13,
				port_bef_switch12,
				port_bef_switch11,
				port_bef_switch10,
				port_bef_switch9,
				port_bef_switch8,
				port_bef_switch7,
				port_bef_switch6,
				port_bef_switch5,
				port_bef_switch4,
				port_bef_switch3,
				port_bef_switch2,
				port_bef_switch1,
				port_bef_switch0,
				port_akku_switch39,
				port_akku_switch38,
				port_akku_switch37,
				port_akku_switch36,
				port_akku_switch35,
				port_akku_switch34,
				port_akku_switch33,
				port_akku_switch32,
				port_akku_switch31,
				port_akku_switch30,
				port_akku_switch29,
				port_akku_switch28,
				port_akku_switch27,
				port_akku_switch26,
				port_akku_switch25,
				port_akku_switch24,
				port_akku_switch23,
				port_akku_switch22,
				port_akku_switch21,
				port_akku_switch20,
				port_akku_switch19,
				port_akku_switch18,
				port_akku_switch17,
				port_akku_switch16,
				port_akku_switch15,
				port_akku_switch14,
				port_akku_switch13,
				port_akku_switch12,
				port_akku_switch11,
				port_akku_switch10,
				port_akku_switch9,
				port_akku_switch8,
				port_akku_switch7,
				port_akku_switch6,
				port_akku_switch5,
				port_akku_switch4,
				port_akku_switch3,
				port_akku_switch2,
				port_akku_switch1,
				port_akku_switch0,
				port_stop,
				port_weiter,
				port_start,
				port_akku_ueb,
				port_bef_ueb);
#endif /* HAVE_GTK */
	case GUI_NULL:
		return (void *) 1;
	default:
		assert(0);
	}
}

void
zuse23_console_gui_destroy(void *_cpssp)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		zuse23_console_gui_gtk_destroy(_cpssp);
		break;
#endif /* HAVE_GTK */
	case GUI_NULL:
		/* Nothing to do... */
		break;
	default:
		assert(0);
	}
}

void
zuse23_console_gui_suspend(void *_cpssp, FILE *fp)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		zuse23_console_gui_gtk_suspend(_cpssp, fp);
		break;
#endif /* HAVE_GTK */
	case GUI_NULL:
		/* Nothing to do... */
		break;
	default:
		assert(0);
	}
}

void
zuse23_console_gui_resume(void *_cpssp, FILE *fp)
{
	switch (selected_gui) {
#ifdef HAVE_GTK
	case GUI_GTK:
		zuse23_console_gui_gtk_resume(_cpssp, fp);
		break;
#endif /* HAVE_GTK */
	case GUI_NULL:
		/* Nothing to do... */
		break;
	default:
		assert(0);
	}
}
