/*
 * Copyright (C) 2015 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#ifdef STATE

#ifdef INP_0
#define IN_N 1
#endif

#include "zuse_generic.c"

#endif /*STATE*/

#ifdef BEHAVIOUR

/* beautiful helper macros to create the function names*/
#define PASTER(x,y,z)       x ## _ ## y ## _ ## z
#define EVALUATOR(x,y,z)    PASTER(x,y,z)

/* macros to concat function names */
#ifdef INP_0
#define NAME_IN_PORT_0_(z)  EVALUATOR(NAME, INP_0, z)
#endif

#ifdef OUTP_0
#define NAME_OUT_PORT_0_(z) EVALUATOR(NAME, OUTP_0, z)
#endif

/* Debug makros */
#if DEBUG

#ifndef STR
#define STR(x)   #x
#endif /* STR */

#ifndef SHOW_DEFINE
#define SHOW_DEFINE(x) fprintf(stderr, "%s", STR(x))
#endif /* SHOW_DEFINE */

#endif /* DEBUG */

static void
NAME_(destroy)(struct cpssp *cpssp)
{
    return;
}

static void
NAME_(solve)(struct cpssp *cpssp) {


    /* macht eigentlich ein kurzes delay um beim druecken eines Schalters nicht
     * viele 0er und 1er zu schicken (mechanisches schalten) kann hier ignoriert
     * werden */
    unsigned int res = 2000 < SIG_mV(cpssp->NAME.states[0]) ? SIG_STD_LOGIC_1 : SIG_STD_LOGIC_0;

#if DEBUG
    SHOW_DEFINE(NAME);
    fprintf(stderr, " sets to %i\n", res);
#endif /* DEBUG */

    NAME_OUT_PORT_0_(out_set)(cpssp, res);

}

#include "zuse_generic.c"

static void
NAME_(create)(struct cpssp *cpssp)
{
    NAME_IN_PORT_0_(in_set)(cpssp, SIG_STD_LOGIC_Z);
}

#ifdef INP_0
#undef NAME_IN_PORT_0_
#undef INP_0
#endif

#ifdef OUTP_0
#undef OUTP_0
#undef NAME_OUT_PORT_0_
#endif

#endif /*BEHAVIOUR*/
