/*
 * Copyright (C) 2016 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#include <stdio.h>

#ifndef __GLUE_GUI_GTK_CONTROL_KNOB_H_INCLUDED
#define __GLUE_GUI_GTK_CONTROL_KNOB_H_INCLUDED

typedef struct {
	GtkVBox parent;

	GtkWidget *label; 
	GtkWidget *combo_box;
	int number_items;
	char **items;
} GuiGtkControlKnob;

#define GUI_GTK_TYPE_CONTROL_KNOB	(gui_gtk_control_knob_get_type())
#define GUI_GTK_CONTROL_KNOB(obj)	(G_TYPE_CHECK_INSTANCE_CAST((obj), GUI_GTK_TYPE_CONTROL_KNOB, GuiGtkControlKnob))

extern GType
gui_gtk_control_knob_get_type(void);

extern GtkWidget *
gui_gtk_control_knob_new(const char *desc, int number_entries, const char **entries);

extern void
gui_gtk_control_knob_set_value(gpointer _control_knob, const char *value_string);

extern void
gui_gtk_control_knob_destroy(gpointer _control_knob);

#endif /* __GLUE_GUI_GTK_CONTROL_KNOB_H_INCLUDED */
