/*
 * Copyright (C) 2007-2009 FAUmachine Team <info@faumachine.org>.
 * This program is free software. You can redistribute it and/or modify it
 * under the terms of the GNU General Public License, either version 2 of
 * the License, or (at your option) any later version. See COPYING.
 */

#ifndef __SIG_INTEGER_H_INCLUDED
#define __SIG_INTEGER_H_INCLUDED

#include "sig_gen.h"

struct sig_integer_funcs {
	void (*set)(void *s, int val);
};

struct sig_integer {
	enum sig_gen_type type;
	struct {
		void *s;
		const struct sig_integer_funcs *f;
		int in;
	} in[64];
	unsigned int in_count;

	struct {
		void *s;
		int out;
	} out[2];
	unsigned int out_count;
};

struct sig_integer_merge {
	struct sig_integer *s0;
	struct sig_integer *s1;
};

extern void
sig_integer_set(struct sig_integer *b, void *s, int val);

extern void
sig_integer_connect_in(
	struct sig_integer *b,
	void *s,
	const struct sig_integer_funcs *f
);
extern void
sig_integer_connect_out(
	struct sig_integer *b,
	void *s,
	int val
);

extern struct sig_integer_merge *
sig_integer_merge(struct sig_integer *s0, struct sig_integer *s1);
extern void
sig_integer_split(struct sig_integer_merge *m);

extern struct sig_integer *
sig_integer_create(const char *name);
extern void
sig_integer_destroy(struct sig_integer *sig);

extern void
sig_integer_suspend(struct sig_integer *b, FILE *fSig);
extern void
sig_integer_resume(struct sig_integer *b, FILE *fSig);

#endif /* __SIG_INTEGER_H_INCLUDED */
